Fix a typo in the comment and add a (somewhat vague) description of the values returned.
[kugel-rb/myfork.git] / tools / rockboxdev.sh
blob079c8c5c0e1cfb89d47ee1e982f337cce16c5730
1 #!/bin/sh
3 # Abort execution as soon as an error is encountered
4 # That way the script do not let the user think the process completed correctly
5 # and leave the opportunity to fix the problem and restart compilation where
6 # it stopped
7 set -e
9 # this is where this script will store downloaded files and check for already
10 # downloaded files
11 dlwhere="${RBDEV_DOWNLOAD:-/tmp/rbdev-dl}"
13 # will append the target string to the prefix dir mentioned here
14 # Note that the user running this script must be able to do make install in
15 # this given prefix directory. Also make sure that this given root dir
16 # exists.
17 prefix="${RBDEV_PREFIX:-/usr/local}"
19 # This directory is used to extract all files and to build everything in. It
20 # must not exist before this script is invoked (as a security measure).
21 builddir="${RBDEV_BUILD:-/tmp/rbdev-build}"
23 # This script needs to use GNU Make. On Linux systems, GNU Make is invoked
24 # by running the "make" command, on most BSD systems, GNU Make is invoked
25 # by running the "gmake" command. Set the "make" variable accordingly.
26 if [ -f "`which gmake 2>/dev/null`" ]; then
27 make="gmake"
28 else
29 make="make"
32 if [ -z $GNU_MIRROR ] ; then
33 GNU_MIRROR=ftp://ftp.gnu.org/pub/gnu
36 # If detection fails, override the value of make manually:
37 # make="make"
39 ##############################################################################
42 # These are the tools this script requires and depends upon.
43 reqtools="gcc bzip2 make patch"
46 findtool(){
47 file="$1"
49 IFS=":"
50 for path in $PATH
52 # echo "Checks for $file in $path" >&2
53 if test -f "$path/$file"; then
54 echo "$path/$file"
55 return
57 done
60 input() {
61 read response
62 echo $response
65 #$1 file
66 #$2 URL"root
67 getfile() {
68 tool=`findtool curl`
69 if test -z "$tool"; then
70 tool=`findtool wget`
71 if test -n "$tool"; then
72 # wget download
73 echo "ROCKBOXDEV: Downloading $2/$1 using wget"
74 $tool -O $dlwhere/$1 $2/$1
76 else
77 # curl download
78 echo "ROCKBOXDEV: Downloading $2/$1 using curl"
79 $tool -Lo $dlwhere/$1 $2/$1
82 if [ $? -ne 0 ] ; then
83 echo "ROCKBOXDEV: couldn't download the file!"
84 echo "ROCKBOXDEV: check your internet connection"
85 exit
88 if test -z "$tool"; then
89 echo "ROCKBOXDEV: No downloader tool found!"
90 echo "ROCKBOXDEV: Please install curl or wget and re-run the script"
91 exit
95 for t in $reqtools; do
96 tool=`findtool $t`
97 if test -z "$tool"; then
98 echo "ROCKBOXDEV: $t is required for this script to work."
99 echo "ROCKBOXDEV: Please install $t and re-run the script."
100 exit
102 done
104 ###########################################################################
105 # Verify download directory or create it
106 if test -d "$dlwhere"; then
107 if ! test -w "$dlwhere"; then
108 echo "$dlwhere exists, but doesn't seem to be writable for you"
109 exit
111 else
112 mkdir $dlwhere
113 if test $? -ne 0; then
114 echo "$dlwhere is missing and we failed to create it!"
115 exit
117 echo "$dlwhere has been created to store downloads in"
120 echo "Download directory: $dlwhere (set RBDEV_DOWNLOAD to change dir)"
121 echo "Install prefix: $prefix/[target] (set RBDEV_PREFIX to change dir)"
122 echo "Build dir: $builddir (set RBDEV_BUILD to change dir)"
124 ###########################################################################
125 # Verify that the prefix dir exists and that we can write to it,
126 # as otherwise we will hardly be able to install there!
127 if test ! -d $prefix; then
128 echo "WARNING: The installation destination does not exist."
129 echo "Please create it and re-run this script"
130 exit
132 if test ! -w $prefix; then
133 echo "WARNING: This script is set to install in $prefix but has no write permissions for it"
134 echo "Please fix this and re-run this script"
135 exit
140 cleardir () {
141 # $1 is the name of the build dir
142 # delete the build dirs and the source dirs
143 rm -rf $1/build-gcc $1/build-binu $1/gcc* $1/binutils*
146 buildone () {
148 arch=$1
149 gccpatch="" # default is no gcc patch
150 gccver="4.0.3" # default gcc version
151 binutils="2.16.1" # The binutils version to use
152 gccconfigure="" #default is nothing added to configure
153 binutilsconf="" #default is nothing added to configure
155 system=`uname -s`
156 gccurl="http://www.rockbox.org/gcc"
158 case $arch in
159 [Ss])
160 target="sh-elf"
161 gccpatch="gcc-4.0.3-rockbox-1.diff"
163 [Mm])
164 target="m68k-elf"
165 gccver="3.4.6"
166 case $system in
167 CYGWIN* | Darwin | FreeBSD | Interix)
168 gccpatch="gcc-3.4.6.patch"
170 Linux)
171 machine=`uname -m`
172 case $machine in
173 x86_64)
174 gccpatch="gcc-3.4.6-amd64.patch"
176 esac
180 esac
182 [Aa])
183 target="arm-elf"
184 gccpatch="rockbox-multilibs-arm-elf-gcc-4.0.3_2.diff"
186 [Ii])
187 target="mipsel-elf"
188 gccver="4.1.2"
189 binutils="2.17"
190 gccconfigure="--disable-libssp"
191 binutilsconf="--disable-werror"
192 # necessary to make binutils build on gcc 4.3+
193 case $system in
194 Interix)
195 gccpatch="gcc-4.1.2-interix.diff"
199 esac
202 echo "An unsupported architecture option: $arch"
203 exit
205 esac
207 bindir="$prefix/$target/bin"
208 if test -n $pathadd; then
209 pathadd="$pathadd:$bindir"
210 else
211 pathadd="$bindir"
214 echo ""
215 echo "In case you encounter a slow internet connection, you can use an alternative mirror."
216 echo "A list of other GNU mirrors is available here: http://www.gnu.org/prep/ftp.html"
217 echo ""
218 echo "Usage: GNU_MIRROR=[URL] ./rockboxdev.sh"
219 echo ""
220 echo "Example:"
221 echo "$ GNU_MIRROR=http://mirrors.kernel.org/gnu ./rockboxdev.sh"
222 echo ""
224 if test -f "$dlwhere/binutils-$binutils.tar.bz2"; then
225 echo "binutils $binutils already downloaded"
226 else
227 getfile binutils-$binutils.tar.bz2 $GNU_MIRROR/binutils
230 if test -f "$dlwhere/gcc-core-$gccver.tar.bz2"; then
231 echo "gcc $gccver already downloaded"
232 else
233 getfile gcc-core-$gccver.tar.bz2 $GNU_MIRROR/gcc/gcc-$gccver
236 if test -n "$gccpatch"; then
237 if test -f "$dlwhere/$gccpatch"; then
238 echo "$gccpatch already downloaded"
239 else
240 getfile "$gccpatch" "$gccurl"
244 ###########################################################################
245 # If there's already a build dir, we don't overwrite or delete it
246 if test -d $builddir; then
247 echo "You already have a $builddir directory!"
248 echo "Please remove it and re-run the script"
249 exit
250 else
251 mkdir -p $builddir
252 cd $builddir
255 ###########################################################################
256 # Create a summary file for each toolchain, containing info about the version
257 # and a remainder to append the compiler path to PATH
259 summary="summary-$1"
261 echo "============================ Summary ============================" > $summary
262 echo "target: $target" >> $summary
263 echo "gcc version: $gccver" >> $summary
264 if test -n "$gccpatch"; then
265 echo "gcc patch: $gccpatch" >> $summary
267 echo "binutils: $binutils" >> $summary
268 echo "installation target: $prefix/$target" >> $summary
269 echo "" >> $summary
270 echo "When done, append $bindir to PATH" >> $summary
271 echo "=================================================================" >> $summary
273 cat $summary
275 echo "ROCKBOXDEV: extracting binutils-$binutils in $builddir"
276 tar xjf $dlwhere/binutils-$binutils.tar.bz2
277 echo "ROCKBOXDEV: extracting gcc-$gccver in $builddir"
278 tar xjf $dlwhere/gcc-core-$gccver.tar.bz2
280 if test -n "$gccpatch"; then
281 echo "ROCKBOXDEV: applying gcc patch"
282 patch -p0 < "$dlwhere/$gccpatch"
285 echo "ROCKBOXDEV: mkdir build-binu"
286 mkdir build-binu
287 echo "ROCKBOXDEV: cd build-binu"
288 cd build-binu
289 echo "ROCKBOXDEV: binutils/configure"
290 # we undefine _FORTIFY_SOURCE to make the binutils built run fine on recent
291 # Ubuntu installations
292 CFLAGS=-U_FORTIFY_SOURCE ../binutils-$binutils/configure --target=$target --prefix=$prefix/$target $binutilsconf
293 echo "ROCKBOXDEV: binutils/make"
294 $make
295 echo "ROCKBOXDEV: binutils/make install to $prefix/$target"
296 $make install
297 cd .. # get out of build-binu
298 PATH="$bindir:${PATH}"
299 SHELL=/bin/sh # seems to be needed by the gcc build in some cases
301 echo "ROCKBOXDEV: mkdir build-gcc"
302 mkdir build-gcc
303 echo "ROCKBOXDEV: cd build-gcc"
304 cd build-gcc
305 echo "ROCKBOXDEV: gcc/configure"
306 # we undefine _FORTIFY_SOURCE to make the gcc build go through fine on
307 # recent Ubuntu installations
308 CFLAGS=-U_FORTIFY_SOURCE ../gcc-$gccver/configure --target=$target --prefix=$prefix/$target --enable-languages=c $gccconfigure
309 echo "ROCKBOXDEV: gcc/make"
310 $make
311 echo "ROCKBOXDEV: gcc/make install to $prefix/$target"
312 $make install
313 cd .. # get out of build-gcc
314 cd .. # get out of $builddir
316 # end of buildone() function
319 echo ""
320 echo "Select target arch:"
321 echo "s - sh (Archos models)"
322 echo "m - m68k (iriver h1x0/h3x0, ifp7x0 and iaudio)"
323 echo "a - arm (ipods, iriver H10, Sansa, etc)"
324 echo "i - mips (Jz4740 and ATJ-based players)"
325 echo "separate multiple targets with spaces"
326 echo "(i.e. \"s m a\" will build sh, m86k and arm)"
327 echo ""
329 selarch=`input`
331 for arch in $selarch
333 echo ""
334 case $arch in
335 [Ss])
336 buildone $arch
338 [Ii])
339 buildone $arch
341 [Mm])
342 buildone $arch
344 [Aa])
345 buildone $arch
348 echo "An unsupported architecture option: $arch"
349 exit
351 esac
353 echo "Cleaning up build folder"
354 cleardir $builddir
355 echo ""
356 echo "Done!"
357 echo ""
358 echo "Make your PATH include $pathadd"
360 done
362 # show the summaries:
363 cat $builddir/summary-*